#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules

//converting KeyCode from keyboard(j106) to PC format
BYTE MakeConversionTable(BYTE TargetCode)
{
 if (TargetCode == 0x01) return(0x1E);	// 1!
 if (TargetCode == 0x02) return(0x1F);	// 2"
 if (TargetCode == 0x03) return(0x20);	// 3#
 if (TargetCode == 0x04) return(0x21);	// 4$
 if (TargetCode == 0x05) return(0x22);	// 5%
 if (TargetCode == 0x06) return(0x23);	// 6&
 if (TargetCode == 0x07) return(0x24);	// 7'
 if (TargetCode == 0x08) return(0x25);	// 8(
 if (TargetCode == 0x09) return(0x26);	// 9)
 if (TargetCode == 0x10) return(0x27);	// 0
 if (TargetCode == 0x23) return(0x2D);	// -=
 if (TargetCode == 0x24) return(0x2E);	// ^~
 if (TargetCode == 0x18) return(0x28);	// Enter
 if (TargetCode == 0x21) return(0x14);	// qQ
 if (TargetCode == 0x0A) return(0x1A);	// wW
 if (TargetCode == 0x0B) return(0x08);	// eE
 if (TargetCode == 0x0C) return(0x15);	// rR
 if (TargetCode == 0x0D) return(0x17);	// tT
 if (TargetCode == 0x0F) return(0x1C);	// yY
 if (TargetCode == 0x0E) return(0x18);	// uU
 if (TargetCode == 0x28) return(0x0C);	// iI
 if (TargetCode == 0x29) return(0x12);	// oO
 if (TargetCode == 0x2A) return(0x13);	// pP
 if (TargetCode == 0x11) return(0x04);	// aA
 if (TargetCode == 0x12) return(0x16);	// sS
 if (TargetCode == 0x13) return(0x07);	// dD
 if (TargetCode == 0x14) return(0x09);	// fF
 if (TargetCode == 0x15) return(0x0A);	// gG
 if (TargetCode == 0x17) return(0x0B);	// hH
 if (TargetCode == 0x16) return(0x0D);	// jJ
 if (TargetCode == 0x30) return(0x0E);	// kK
 if (TargetCode == 0x31) return(0x0F);	// lL
 if (TargetCode == 0x19) return(0x1D);	// zZ
 if (TargetCode == 0x1A) return(0x1B);	// xX
 if (TargetCode == 0x1B) return(0x06);	// cC
 if (TargetCode == 0x1C) return(0x19);	// vV
 if (TargetCode == 0x1D) return(0x05);	// bB
 if (TargetCode == 0x1F) return(0x11);	// nN
 if (TargetCode == 0x1E) return(0x10);	// mM
 if (TargetCode == 0x38) return(0x36);	// ,<
 if (TargetCode == 0x39) return(0x37);	// .>
// if (TargetCode == 0x00) return(0x38);	// /?
// if (TargetCode == 0x00) return(0x35);	// hankaku/zenkaku
// if (TargetCode == 0x00) return(0x89);	// international key \(Yen)|
// if (TargetCode == 0x00) return(0x2A);	// BackSpace
// if (TargetCode == 0x00) return(0x2B);	// TAB
// if (TargetCode == 0x00) return(0x30);	// [{
// if (TargetCode == 0x00) return(0x39);	// Caps Lock
// if (TargetCode == 0x00) return(0x33);	// ;+
// if (TargetCode == 0x00) return(0x34);	// :*
// if (TargetCode == 0x00) return(0x32);	// ]}
// if (TargetCode == 0x00) return(0x87);	// \_
// if (TargetCode == 0x00) return(0x50);	// <- (Arrow)
// if (TargetCode == 0x00) return(0x4F);	// -> (Arrow)
// if (TargetCode == 0x00) return(0x52);	//  (up Arrow) 
// if (TargetCode == 0x00) return(0x51);	//  (down Arrow) 
// if (TargetCode == 0x00) return(0x4B);	//  (Page Up)
// if (TargetCode == 0x00) return(0x4E);	//  (Page Down) 

 
 return(0);	//no key pressed
}