//I2C to USB Keyboard
#include <m8c.h>        
#include "PSoCAPI.h"    
#include "psocgpioint.h"

BYTE MakeConversionTable(BYTE TargetCode);	//converting keykode from keyboard to PC format

BYTE keycode[8] = {0, 0, 0, 0, 0, 0, 0, 0};  //keykode array which we write to USB. 3 byte is Keykode, 0 - modifier

//I2C buffer
BYTE    rxBuffer[2] = {0xFF, 0x00};  
//set slave address
#define SLAVE_ADDRESS 0x10

void main(void)  
{  
	//Start I2CHW_Master
    I2CHW_Start();  
    I2CHW_EnableMstr();
	I2CHW_EnableInt();
	
	M8C_EnableGInt;                    		 //Enable Global Interrupts  
	
	USBFS_Start(0, USB_5V_OPERATION);    	 //Start USBFS Operation using device 0 and with 5V operation  
	while(!USBFS_bGetConfiguration());   	 //Wait for Device to enumerate  

	//Enumeration is completed load endpoint 1. Do not toggle the first time  
	USBFS_LoadInEP(1, keycode, 8, USB_NO_TOGGLE);  
	
	//main Loop
	while(1)  
	{  
	  I2CHW_ClrRdStatus(); 	      
      I2CHW_fReadBytes(SLAVE_ADDRESS, rxBuffer, 2, I2CHW_CompleteXfer);		//Read from the slave and place in rxBuffer   
        
      while(!I2CHW_bReadI2CStatus() & I2CHW_RD_COMPLETE );					//Wait until the data is read  
	  while(!USBFS_bGetEPAckState(1));    									//Wait for ACK before loading data  
	  //ACK has occurred, load the endpoint and toggle the data bit  
	  USBFS_LoadInEP(1, keycode, 8, USB_TOGGLE);  
      //converting read from Keyboard scan code to PC format
      keycode[2]=MakeConversionTable(rxBuffer[0]);      	
      if ((rxBuffer[1]&0x10) != 0) keycode[0]|=0x02;		//shift key ON
      else keycode[0]&=(~0x02);							  
	}  
}  
