	cpu LMM
	.module main.c
	.area data(ram, con, rel)
_keycode::
	.byte 0,0
	.byte 0,0
	.byte 0,0
	.byte 0,0
	.dbfile ./main.c
	.dbsym e keycode _keycode A[8:8]c
	.area data(ram, con, rel)
	.dbfile ./main.c
	.area data(ram, con, rel)
	.dbfile ./main.c
_rxBuffer::
	.byte 255,0
	.dbsym e rxBuffer _rxBuffer A[2:2]c
	.area data(ram, con, rel)
	.dbfile ./main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 16
; //I2C to USB Keyboard
; #include <m8c.h>        
; #include "PSoCAPI.h"    
; #include "psocgpioint.h"
; 
; BYTE MakeConversionTable(BYTE TargetCode);	//converting keykode from keyboard to PC format
; 
; BYTE keycode[8] = {0, 0, 0, 0, 0, 0, 0, 0};  //keykode array which we write to USB. 3 byte is Keykode, 0 - modifier
; 
; //I2C buffer
; BYTE    rxBuffer[2] = {0xFF, 0x00};  
; //set slave address
; #define SLAVE_ADDRESS 0x10
; 
; void main(void)  
; {  
	.dbline 18
; 	//Start I2CHW_Master
;     I2CHW_Start();  
	push X
	xcall _I2CHW_Start
	.dbline 19
;     I2CHW_EnableMstr();
	xcall _I2CHW_EnableMstr
	.dbline 20
; 	I2CHW_EnableInt();
	xcall _I2CHW_EnableInt
	pop X
	.dbline 22
; 	
; 	M8C_EnableGInt;                    		 //Enable Global Interrupts  
		or  F, 01h

	.dbline 24
; 	
; 	USBFS_Start(0, USB_5V_OPERATION);    	 //Start USBFS Operation using device 0 and with 5V operation  
	push X
	mov X,3
	mov A,0
	xcall _USBFS_Start
	pop X
L3:
	.dbline 25
L4:
	.dbline 25
; 	while(!USBFS_bGetConfiguration());   	 //Wait for Device to enumerate  
	push X
	xcall _USBFS_bGetConfiguration
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L3
	.dbline 28
; 
; 	//Enumeration is completed load endpoint 1. Do not toggle the first time  
; 	USBFS_LoadInEP(1, keycode, 8, USB_NO_TOGGLE);  
	push X
	mov A,0
	push A
	push A
	mov A,8
	push A
	mov A,>_keycode
	push A
	mov A,<_keycode
	push A
	mov A,1
	push A
	xcall _USBFS_LoadInEP
	add SP,-6
	pop X
	xjmp L7
L6:
	.dbline 32
; 	
; 	//main Loop
; 	while(1)  
; 	{  
	.dbline 33
; 	  I2CHW_ClrRdStatus(); 	      
	push X
	xcall _I2CHW_ClrRdStatus
	.dbline 34
;       I2CHW_fReadBytes(SLAVE_ADDRESS, rxBuffer, 2, I2CHW_CompleteXfer);		//Read from the slave and place in rxBuffer   
	mov A,0
	push A
	mov A,2
	push A
	mov A,>_rxBuffer
	push A
	mov A,<_rxBuffer
	push A
	mov A,16
	push A
	xcall _I2CHW_fReadBytes
	add SP,-5
	pop X
L9:
	.dbline 36
L10:
	.dbline 36
;         
;       while(!I2CHW_bReadI2CStatus() & I2CHW_RD_COMPLETE );					//Wait until the data is read  
	push X
	xcall _I2CHW_bReadI2CStatus
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jnz L13
	mov [X+1],1
	mov [X+0],0
	xjmp L14
L13:
	mov [X+1],0
	mov [X+0],0
L14:
	mov REG[0xd0],>__r0
	mov A,[X+1]
	and A,4
	mov [__r1],A
	mov A,[X+0]
	and A,0
	cmp A,0
	jnz L9
	cmp [__r1],0
	jnz L9
X1:
L15:
	.dbline 37
L16:
	.dbline 37
; 	  while(!USBFS_bGetEPAckState(1));    									//Wait for ACK before loading data  
	push X
	mov A,1
	xcall _USBFS_bGetEPAckState
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L15
	.dbline 39
; 	  //ACK has occurred, load the endpoint and toggle the data bit  
; 	  USBFS_LoadInEP(1, keycode, 8, USB_TOGGLE);  
	push X
	mov A,1
	push A
	mov A,0
	push A
	mov A,8
	push A
	mov A,>_keycode
	push A
	mov A,<_keycode
	push A
	mov A,1
	push A
	xcall _USBFS_LoadInEP
	add SP,-6
	pop X
	.dbline 41
;       //converting read from Keyboard scan code to PC format
;       keycode[2]=MakeConversionTable(rxBuffer[0]);      	
	mov REG[0xd0],>_rxBuffer
	mov A,[_rxBuffer]
	push A
	xcall _MakeConversionTable
	add SP,-1
	mov REG[0xd0],>_keycode
	mov [_keycode+2],A
	.dbline 42
;       if ((rxBuffer[1]&0x10) != 0) keycode[0]|=0x02;		//shift key ON
	mov REG[0xd0],>_rxBuffer
	tst [_rxBuffer+1],16
	jz L19
	.dbline 42
	mov REG[0xd0],>_keycode
	mov A,[_keycode]
	or A,2
	mov [_keycode],A
	xjmp L20
L19:
	.dbline 43
;       else keycode[0]&=(~0x02);							  
	mov REG[0xd0],>_keycode
	and [_keycode],-3
L20:
	.dbline 44
L7:
	.dbline 31
	xjmp L6
X0:
	.dbline -2
	.dbline 45
; 	}  
; }  
L2:
	add SP,-2
	pop X
	.dbline 0 ; func end
	jmp .
	.dbend
