//----------------------------------------------------------------------------
// C main line
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "stdlib.h"
 
char ADC_Buffer[4];
BYTE RXBuffer[2];  

void Send_Lux(void);
void I2C_send(void) ;
void convert(unsigned int);
void Send_ADCValue(void);


void main()
{   
	unsigned int iData;
	M8C_EnableGInt;
    DigBuf_1_Start();  
    ADC10_1_Start(ADC10_1_FULLRANGE);      			// Start the User Module    
    ADC10_1_iCal(0x128, ADC10_1_CAL_VBG);			//set 1.3V to 0x128
    ADC10_1_StartADC();                  			// Begin sampling        
   	
    I2CHW_Start(); 									//Start the slave and wait for the master 
    I2CHW_EnableSlave();  
	
    M8C_EnableGInt;  								//Enable the global and local interrupts  
    I2CHW_EnableInt();  
    
    I2CHW_InitRamRead(RXBuffer,2);  				//Setup the Read and Write Buffer - set to the same buffer 
	 while(1)
	 {  
	 	while(0 == ADC10_1_fIsDataAvailable());    
	    iData = ADC10_1_iGetDataClearFlag();    
	 	convert(iData);  	
		Send_ADCValue();
		Send_Lux();	
	 }
}

	void I2C_send(void) 											//Data send to I2C_Master
    {
    	unsigned int delay;
    	
      	while(!I2CHW_bReadI2CStatus() & I2CHW_RD_COMPLETE ); 		//wait for Master read complete 
			      
		I2CHW_ClrRdStatus();  										
		I2CHW_InitRamRead(RXBuffer,2);
		for(delay=0;delay<20000;delay++){};
     } 
     
	void convert(unsigned int iData)								//convert Raw data to decimal.
	{
		unsigned int result;
		
		result = iData*9*2/5;
		ADC_Buffer[3]=result-(result/10)*10;
		ADC_Buffer[2]=result/10-(result/100)*10;
		ADC_Buffer[1]=result/100-(result/1000)*10;
		ADC_Buffer[0]=result/1000;
		
		if(ADC_Buffer[3]==0){ADC_Buffer[3]=0x10;}
		if(ADC_Buffer[2]==0){ADC_Buffer[2]=0x10;}
		if(ADC_Buffer[1]==0){ADC_Buffer[1]=0x10;}
		if(ADC_Buffer[0]==0||ADC_Buffer[0]==0x0D){ADC_Buffer[0]=0x10;}
			
	}

	void Send_ADCValue(void)										//ADC value convert to decimal and send to I2C_master keycode.
	{																//if you need more information. please refer master project.
		RXBuffer[0]=ADC_Buffer[0];
		RXBuffer[1]=0x00;
		I2C_send();
		
		RXBuffer[0]=ADC_Buffer[1];
		RXBuffer[1]=0x00;
		I2C_send();
		
		
		RXBuffer[0]=ADC_Buffer[2];
		RXBuffer[1]=0x00;
		I2C_send();
		
		RXBuffer[0]=ADC_Buffer[3];
		RXBuffer[1]=0x00;
		I2C_send();
	}
	
	
	void Send_Lux(void)												//I2C master keycode of ",LUX[Enter]"
	{
   		RXBuffer[0]=0x38;											//,
	    RXBuffer[1]=0x00;
		I2C_send();
							
	    RXBuffer[0]=0x31;											//L
	    RXBuffer[1]=0x10;
		I2C_send();
					
		RXBuffer[0]=0x0E;											//U	
	    RXBuffer[1]=0x10;
		I2C_send();
		
		RXBuffer[0]=0x1A;											//X
	    RXBuffer[1]=0x10;
		I2C_send();
		
		RXBuffer[0]=0x18;											//Enter
	    RXBuffer[1]=0x00;
		I2C_send();
	}
	     
