	cpu LMM
	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
;          iData -> X+0
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 19
; //----------------------------------------------------------------------------
; // C main line
; //----------------------------------------------------------------------------
; 
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; #include "stdlib.h"
;  
; char ADC_Buffer[4];
; BYTE RXBuffer[2];  
; 
; void Send_Lux(void);
; void I2C_send(void) ;
; void convert(unsigned int);
; void Send_ADCValue(void);
; 
; 
; void main()
; {   
	.dbline 21
; 	unsigned int iData;
; 	M8C_EnableGInt;
		or  F, 01h

	.dbline 22
;     DigBuf_1_Start();  
	push X
	xcall _DigBuf_1_Start
	.dbline 23
;     ADC10_1_Start(ADC10_1_FULLRANGE);      			// Start the User Module    
	mov A,3
	xcall _ADC10_1_Start
	.dbline 24
;     ADC10_1_iCal(0x128, ADC10_1_CAL_VBG);			//set 1.3V to 0x128
	mov A,3
	push A
	mov A,1
	push A
	mov A,40
	push A
	xcall _ADC10_1_iCal
	mov REG[0xd0],>__r0
	add SP,-3
	.dbline 25
;     ADC10_1_StartADC();                  			// Begin sampling        
	xcall _ADC10_1_StartADC
	.dbline 27
;    	
;     I2CHW_Start(); 									//Start the slave and wait for the master 
	xcall _I2CHW_Start
	.dbline 28
;     I2CHW_EnableSlave();  
	xcall _I2CHW_EnableSlave
	pop X
	.dbline 30
; 	
;     M8C_EnableGInt;  								//Enable the global and local interrupts  
		or  F, 01h

	.dbline 31
;     I2CHW_EnableInt();  
	push X
	xcall _I2CHW_EnableInt
	.dbline 33
;     
;     I2CHW_InitRamRead(RXBuffer,2);  				//Setup the Read and Write Buffer - set to the same buffer 
	mov A,2
	push A
	mov A,>_RXBuffer
	push A
	mov A,<_RXBuffer
	push A
	xcall _I2CHW_InitRamRead
	add SP,-3
	pop X
	xjmp L3
X0:
	.dbline 35
; 	 while(1)
; 	 {  
L5:
	.dbline 36
L6:
	.dbline 36
	push X
	xcall _ADC10_1_fIsDataAvailable
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L5
	.dbline 37
	push X
	xcall _ADC10_1_iGetDataClearFlag
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 38
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	xcall _convert
	add SP,-2
	.dbline 39
	xcall _Send_ADCValue
	.dbline 40
	xcall _Send_Lux
	.dbline 41
L3:
	.dbline 34
	xjmp L6
X1:
	.dbline -2
	.dbline 42
; 	 	while(0 == ADC10_1_fIsDataAvailable());    
; 	    iData = ADC10_1_iGetDataClearFlag();    
; 	 	convert(iData);  	
; 		Send_ADCValue();
; 		Send_Lux();	
; 	 }
; }
L1:
	add SP,-2
	pop X
	.dbline 0 ; func end
	jmp .
	.dbsym l iData 0 i
	.dbend
	.dbfunc e I2C_send _I2C_send fV
;          delay -> X+0
_I2C_send::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 45
; 
; 	void I2C_send(void) 											//Data send to I2C_Master
;     {
L9:
	.dbline 48
L10:
	.dbline 48
;     	unsigned int delay;
;     	
;       	while(!I2CHW_bReadI2CStatus() & I2CHW_RD_COMPLETE ); 		//wait for Master read complete 
	push X
	xcall _I2CHW_bReadI2CStatus
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jnz L13
	mov [X+3],1
	mov [X+2],0
	xjmp L14
L13:
	mov [X+3],0
	mov [X+2],0
L14:
	mov REG[0xd0],>__r0
	mov A,[X+3]
	and A,4
	mov [__r1],A
	mov A,[X+2]
	and A,0
	cmp A,0
	jnz L9
	cmp [__r1],0
	jnz L9
X2:
	.dbline 50
; 			      
; 		I2CHW_ClrRdStatus();  										
	push X
	xcall _I2CHW_ClrRdStatus
	.dbline 51
; 		I2CHW_InitRamRead(RXBuffer,2);
	mov A,2
	push A
	mov A,>_RXBuffer
	push A
	mov A,<_RXBuffer
	push A
	xcall _I2CHW_InitRamRead
	add SP,-3
	pop X
	.dbline 52
	mov [X+1],0
	mov [X+0],0
	xjmp L18
L15:
	.dbline 52
	.dbline 52
L16:
	.dbline 52
	inc [X+1]
	adc [X+0],0
L18:
	.dbline 52
; 		for(delay=0;delay<20000;delay++){};
	mov A,[X+1]
	sub A,32
	mov A,[X+0]
	sbb A,78
	jc L15
X3:
	.dbline 52
	.dbline -2
	.dbline 53
;      } 
L8:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l delay 0 i
	.dbend
	.dbfunc e convert _convert fV
;         result -> X+0
;          iData -> X-5
_convert::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 56
;      
; 	void convert(unsigned int iData)								//convert Raw data to decimal.
; 	{
	.dbline 59
; 		unsigned int result;
; 		
; 		result = iData*9*2/5;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	push A
	mov A,[X-4]
	push A
	mov A,0
	push A
	mov A,9
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r1],A
	mov A,[__rY]
	mov [__r0],A
	asl [__r1]
	rlc [__r0]
	mov A,0
	push A
	mov A,5
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall __divmodu_16X16_16
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-2
	.dbline 60
; 		ADC_Buffer[3]=result-(result/10)*10;
	mov A,0
	push A
	mov A,10
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	xcall __divmodu_16X16_16
	pop A
	mov [__r1],A
	pop A
	add SP,-2
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,10
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r1],A
	mov A,[X+1]
	sub A,[__r1]
	mov REG[0xd0],>_ADC_Buffer
	mov [_ADC_Buffer+3],A
	.dbline 61
; 		ADC_Buffer[2]=result/10-(result/100)*10;
	mov REG[0xd0],>__r0
	mov A,0
	push A
	mov A,100
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	xcall __divmodu_16X16_16
	pop A
	mov [__r1],A
	pop A
	add SP,-2
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,10
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r1],A
	mov A,0
	push A
	mov A,10
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	xcall __divmodu_16X16_16
	pop A
	mov [__r3],A
	pop A
	add SP,-2
	mov A,[__r3]
	sub A,[__r1]
	mov REG[0xd0],>_ADC_Buffer
	mov [_ADC_Buffer+2],A
	.dbline 62
; 		ADC_Buffer[1]=result/100-(result/1000)*10;
	mov REG[0xd0],>__r0
	mov A,3
	push A
	mov A,-24
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	xcall __divmodu_16X16_16
	pop A
	mov [__r1],A
	pop A
	add SP,-2
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,10
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r1],A
	mov A,0
	push A
	mov A,100
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	xcall __divmodu_16X16_16
	pop A
	mov [__r3],A
	pop A
	add SP,-2
	mov A,[__r3]
	sub A,[__r1]
	mov REG[0xd0],>_ADC_Buffer
	mov [_ADC_Buffer+1],A
	.dbline 63
; 		ADC_Buffer[0]=result/1000;
	mov REG[0xd0],>__r0
	mov A,3
	push A
	mov A,-24
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	xcall __divmodu_16X16_16
	pop A
	mov [__r1],A
	pop A
	add SP,-2
	mov A,[__r1]
	mov REG[0xd0],>_ADC_Buffer
	mov [_ADC_Buffer],A
	.dbline 65
; 		
; 		if(ADC_Buffer[3]==0){ADC_Buffer[3]=0x10;}
	cmp [_ADC_Buffer+3],0
	jnz L23
	.dbline 65
	.dbline 65
	mov [_ADC_Buffer+3],16
	.dbline 65
L23:
	.dbline 66
; 		if(ADC_Buffer[2]==0){ADC_Buffer[2]=0x10;}
	mov REG[0xd0],>_ADC_Buffer
	cmp [_ADC_Buffer+2],0
	jnz L27
	.dbline 66
	.dbline 66
	mov [_ADC_Buffer+2],16
	.dbline 66
L27:
	.dbline 67
; 		if(ADC_Buffer[1]==0){ADC_Buffer[1]=0x10;}
	mov REG[0xd0],>_ADC_Buffer
	cmp [_ADC_Buffer+1],0
	jnz L31
	.dbline 67
	.dbline 67
	mov [_ADC_Buffer+1],16
	.dbline 67
L31:
	.dbline 68
	mov REG[0xd0],>_ADC_Buffer
	cmp [_ADC_Buffer],0
	jz L37
	cmp [_ADC_Buffer],13
	jnz L35
L37:
	.dbline 68
	.dbline 68
	mov REG[0xd0],>_ADC_Buffer
	mov [_ADC_Buffer],16
	.dbline 68
L35:
	.dbline -2
	.dbline 70
; 		if(ADC_Buffer[0]==0||ADC_Buffer[0]==0x0D){ADC_Buffer[0]=0x10;}
; 			
; 	}
L19:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l result 0 i
	.dbsym l iData -5 i
	.dbend
	.dbfunc e Send_ADCValue _Send_ADCValue fV
_Send_ADCValue::
	.dbline -1
	.dbline 73
; 
; 	void Send_ADCValue(void)										//ADC value convert to decimal and send to I2C_master keycode.
; 	{																//if you need more information. please refer master project.
	.dbline 74
; 		RXBuffer[0]=ADC_Buffer[0];
	mov REG[0xd0],>_ADC_Buffer
	mov A,[_ADC_Buffer]
	mov REG[0xd0],>_RXBuffer
	mov [_RXBuffer],A
	.dbline 75
; 		RXBuffer[1]=0x00;
	mov [_RXBuffer+1],0
	.dbline 76
; 		I2C_send();
	xcall _I2C_send
	.dbline 78
; 		
; 		RXBuffer[0]=ADC_Buffer[1];
	mov REG[0xd0],>_ADC_Buffer
	mov A,[_ADC_Buffer+1]
	mov REG[0xd0],>_RXBuffer
	mov [_RXBuffer],A
	.dbline 79
; 		RXBuffer[1]=0x00;
	mov [_RXBuffer+1],0
	.dbline 80
; 		I2C_send();
	xcall _I2C_send
	.dbline 83
; 		
; 		
; 		RXBuffer[0]=ADC_Buffer[2];
	mov REG[0xd0],>_ADC_Buffer
	mov A,[_ADC_Buffer+2]
	mov REG[0xd0],>_RXBuffer
	mov [_RXBuffer],A
	.dbline 84
; 		RXBuffer[1]=0x00;
	mov [_RXBuffer+1],0
	.dbline 85
; 		I2C_send();
	xcall _I2C_send
	.dbline 87
; 		
; 		RXBuffer[0]=ADC_Buffer[3];
	mov REG[0xd0],>_ADC_Buffer
	mov A,[_ADC_Buffer+3]
	mov REG[0xd0],>_RXBuffer
	mov [_RXBuffer],A
	.dbline 88
; 		RXBuffer[1]=0x00;
	mov [_RXBuffer+1],0
	.dbline 89
; 		I2C_send();
	xcall _I2C_send
	.dbline -2
	.dbline 90
; 	}
L38:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Send_Lux _Send_Lux fV
_Send_Lux::
	.dbline -1
	.dbline 94
; 	
; 	
; 	void Send_Lux(void)												//I2C master keycode of ",LUX[Enter]"
; 	{
	.dbline 95
;    		RXBuffer[0]=0x38;											//,
	mov REG[0xd0],>_RXBuffer
	mov [_RXBuffer],56
	.dbline 96
; 	    RXBuffer[1]=0x00;
	mov [_RXBuffer+1],0
	.dbline 97
; 		I2C_send();
	xcall _I2C_send
	.dbline 99
; 							
; 	    RXBuffer[0]=0x31;											//L
	mov REG[0xd0],>_RXBuffer
	mov [_RXBuffer],49
	.dbline 100
; 	    RXBuffer[1]=0x10;
	mov [_RXBuffer+1],16
	.dbline 101
; 		I2C_send();
	xcall _I2C_send
	.dbline 103
; 					
; 		RXBuffer[0]=0x0E;											//U	
	mov REG[0xd0],>_RXBuffer
	mov [_RXBuffer],14
	.dbline 104
; 	    RXBuffer[1]=0x10;
	mov [_RXBuffer+1],16
	.dbline 105
; 		I2C_send();
	xcall _I2C_send
	.dbline 107
; 		
; 		RXBuffer[0]=0x1A;											//X
	mov REG[0xd0],>_RXBuffer
	mov [_RXBuffer],26
	.dbline 108
; 	    RXBuffer[1]=0x10;
	mov [_RXBuffer+1],16
	.dbline 109
; 		I2C_send();
	xcall _I2C_send
	.dbline 111
; 		
; 		RXBuffer[0]=0x18;											//Enter
	mov REG[0xd0],>_RXBuffer
	mov [_RXBuffer],24
	.dbline 112
; 	    RXBuffer[1]=0x00;
	mov [_RXBuffer+1],0
	.dbline 113
; 		I2C_send();
	xcall _I2C_send
	.dbline -2
	.dbline 114
; 	}
L46:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./main.c
_RXBuffer::
	.byte 0,0
	.dbsym e RXBuffer _RXBuffer A[2:2]c
	.area data(ram, con, rel)
	.dbfile ./main.c
_ADC_Buffer::
	.byte 0,0,0,0
	.dbsym e ADC_Buffer _ADC_Buffer A[4:4]c
